#define UNUSED __attribute__ ((unused))
#if __GNUC__ > 3
#define SENTINEL __attribute__ ((sentinel(0)))
#else
#define SENTINEL
#endif

extern XtAppContext context;
extern Widget app_shell;
extern Pixmap bm_printer, bm_printermask, bm_activeprinter, bm_activeprintermask;
struct child;
typedef void collectorcallback(void *frame, const char *data, size_t newsize, bool finished);
bool closeonexec(int fd);
void abortCollector(struct child *child);
void killCollector(struct child *child);
struct child *newCollector(XtAppContext,collectorcallback callback, void *frame, const char *command, char **const args);
struct child *newCollectorVa(XtAppContext,collectorcallback callback, void *frame, const char *command, ...) SENTINEL;
void initCollectors(void);
void registerCollectors(XtAppContext app);
void notified_logged_action(XtAppContext context, Widget parent, XtCallbackProc callback, XtPointer privdata, const char *command, ...) SENTINEL;
#define logged_action(context,parent, ...) notified_logged_action(context, parent, NULL, NULL, __VA_ARGS__ )
enum wmDeleteAction {wmdPopdown, wmdDestroy, wmdIconify};
void setDeleteHandler(Widget shell, enum wmDeleteAction action);
void initDeleteProtocol(Display *display);
bool createMainWindow(Widget app);

enum lpq_state { LPQ_UNKNOWN=-1, LPQ_ENABLED=0, LPQ_DISABLED=1 };
typedef unsigned long timecode;

typedef void summaryCallback(void *, timecode timecode,
		const char *printer, size_t printerlen,
		int jobs,
		enum lpq_state queuestate, enum lpq_state printerstate,
		const char *destination, size_t destinationlen,
		const char *remark, size_t remarklen);
typedef void finishedCallback(void *, timecode timecode);
struct requests;
void requestsFree(struct requests *requests);
struct requests *requestsCreate(const char *lookfor, summaryCallback, finishedCallback,void *frame);
void requestsTrigger(struct requests *r, bool iterative, timecode timecode, const char *username);

void initPrinterWindowData(Widget app_shell);
void printerWindow(const char *printername);

#ifndef HAVE_STRNDUP
char *strndup(const char *str,size_t n);
#endif
